<?php

namespace Bydedi\Avalara\Event;

use Commande;
use Event\CommandeEvent;
use Bydedi\Avalara\Adapter\CommandeAdapter;
use Bydedi\Avalara\AvaTax;
use Bydedi\Avalara\Model\Address;
use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class AvaTaxSubscriber implements EventSubscriberInterface{

    /**
     * @inheritdoc
     */
    public static function getSubscribedEvents(){
        return array(
            CommandeEvent::ADD => array(
                array('commit',0)
            )
        );
    }

    /**
     * @param Event $event
     */
    public function commit(Event $event){
        /** @var Commande $commande */
        $commande = $event->getCommande();

        if($commande->__get('boutique_id') == 15){

            $commandeAdapter = new CommandeAdapter($commande);
            $avatax = AvaTax::getInstance();

            $from = new Address();
            $store = $commande->getStore();
            $from
                ->setLine1($store->__get('store_address'))
                ->setLine2($store->__get('store_addres2'))
                ->setCity($store->__get('store_city'))
                ->setPostalCode($store->__get('store_zip'))
                ->setCountry($store->__get('pays_iso_code_2'));

            // Résolution du code région pour les états américains
            if(!empty($store->__get('catalog_state_us_code'))){
                $from->setRegion($store->__get('catalog_state_us_code'));
            }

            $customer = $commandeAdapter->getCustomer();
            $to = $commandeAdapter->getAddressShipping();
            $shipping = $commandeAdapter->getShipping();
            $products = $commandeAdapter->getProducts();

            $result = $avatax->getTax(AvaTax::INVOICE, $customer, $from, $to, $shipping, $products, true);

            if($result['model']->status != 'Committed'){
                // TODO : Log uncommitted transaction ?
            }
        }
    }

}